diff --git a/core/dynamo.c b/core/dynamo.c
index 8cf2ffc812..4443502e0b 100644
--- a/core/dynamo.c
+++ b/core/dynamo.c
@@ -646,6 +646,11 @@ dynamorio_app_init(void)
         annotation_init();
 #endif
         jitopt_init();
+
+        /* New client threads rely on dr_app_started being initialized, so do
+         * that before initializing clients.
+         */
+        dr_app_started = create_broadcast_event();
 #ifdef CLIENT_INTERFACE
         /* client last, in case it depends on other inits: must be after
          * dynamo_thread_init so the client can use a dcontext (PR 216936).
@@ -704,8 +709,6 @@ dynamorio_app_init(void)
 #endif
     }
 
-    dr_app_started = create_broadcast_event();
-
     dynamo_initialized = true;
 
     /* Protect .data, assuming all vars there have been initialized. */
